// Copyright 2012, 2013 Brad Block, Pawjaw, LLC. (an Ohio Limited Liability Company)
// 
// This file is part of JFPPR. 
// 
// JFPPR is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// JFPPR is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with JFPPR.  If not, see <http://www.gnu.org/licenses/>.

package com.pawjaw.graph.fppr.demo;

import com.pawjaw.graph.fppr.Graph;
import com.pawjaw.graph.fppr.Vertex;
import java.util.LinkedList;
import java.util.List;

public class SimilarSpelledWords {
    public static void main(String[] args) {
        int i, I, j;
        float weight;
        Vertex a, b;
        Graph word_graph;
        List<Integer> vertex_ids = new LinkedList();
        String[] words = new String[] {
            "haviam",
            "possui",
            "provaram",
            "tem",
            "têm",
            "tendo",
            "tenha",
            "tenham",
            "ter",
            "terem",
            "teve",
            "tido",
            "tinha",
            "tinham",
            "tive",
            "tiveram",
            "tivesse",
            "era",
            "está",
            "estão",
            "estará",
            "estarão",
            "estava",
            "estejam",
            "estiverem",
            "fica",
            "ficam",
            "ficará",
            "ficarão",
            "ficava",
            "ficou",
            "foi",
            "for",
            "são",
            "seja",
            "sejam",
            "será",
            "serão",
            "situa",
            "terá",
            "terão",
            "vai",
            "vão"
        };
        word_graph = new Graph(I = words.length);
        for(i = 0;i < I;i++) {
            a = word_graph.vertex(i);
            for(j = i + 1;j < I;j++)
                if((weight = Utils.scaledEditSimilarity(words[i], words[j], 2)) > 0) {
                    b = word_graph.vertex(j);
                    a.addOutgoingEdge(b, weight);
                    b.addOutgoingEdge(a, weight);
                }
        }
        word_graph.walk(100);
        for(i = 0;i < I;i++) {
            System.out.println(words[i]);
            j = 0;
            for(int vertex_id : word_graph.rank(i, 10000, vertex_ids))
                if(j++ == 5)
                    break;
                else
                    System.out.println("  " + words[vertex_id]);
        }
    }
}
